import type { Extension, StateCommand } from '@codemirror/state';
import { EditorView, EditorViewConfig } from '@codemirror/view';
import { EventMap } from '../../bundle/Editor';
import { ReactRenderStorage } from '../../extensions';
import { Receiver } from '../../utils';
import { FileUploadHandler } from './files-upload-facet';
import { type YfmLangOptions } from './yfm';
export type { YfmLangOptions };
export declare type CreateCodemirrorParams = {
    doc: EditorViewConfig['doc'];
    placeholderText: string;
    onCancel: () => void;
    onSubmit: () => void;
    onChange: () => void;
    onDocChange: () => void;
    onScroll: (event: Event) => void;
    reactRenderer: ReactRenderStorage;
    uploadHandler?: FileUploadHandler;
    needImgDimms?: boolean;
    extensions?: Extension[];
    receiver?: Receiver<EventMap>;
    yfmLangOptions?: YfmLangOptions;
};
export declare function createCodemirror(params: CreateCodemirrorParams): EditorView;
export declare function withLogger(action: string, command: StateCommand): StateCommand;
